#!/bin/sh

PATH=/bin:/sbin:/usr/bin:/usr/sbin
if [ $REQUEST_METHOD = POST ]; then
        strparam=`cat $stdin | cut -c1-$CONTENT_LENGTH`
else
        strparam=$QUERY_STRING
fi
strparam=`decode.sh $strparam`

if [ -L $0 ] ; then
    BASEDIR=$(cd "$(dirname "$(readlink $0)")"; pwd -P) # for symbolic link
else
    BASEDIR=$(cd "$(dirname "$0")"; pwd -P) # for normal file
fi

HOSTNAME=`confclient -p 99 -g system_host_name | cut -d "=" -f2`
BINPATH="/usr/bin"
VCA_CFG_PATH="${BASEDIR}/../conf.d/vca"
REPORT_PUSH_CFG="${VCA_CFG_PATH}/config_vca_reportpush.xml"
VCA_CAPABILITY_CFG="${VCA_CFG_PATH}/config_vca_capability.xml"
TINY_XML="/usr/bin/tinyxmlparser"

getReportPushItemVal()
{
	xmlPath=$1

	${TINY_XML} -x "${xmlPath}" -f "${REPORT_PUSH_CFG}"
}

getVCACapabilityItemVal()
{
	xmlPath=$1

	${TINY_XML} -x "${xmlPath}" -f "${VCA_CAPABILITY_CFG}"
}

logMsg()
{
	logFolder="/mnt/flash2/logs"
	[ ! -d "${logFolder}" ] && mkdir -p "${logFolder}"
	logFile="${logFolder}/report_pull.log"
	limitSize=300 #300KB

	[ "$(du -k "${logFile}" | awk '{print $1}')" -gt ${limitSize} ] && mv "${logFile}" "${logFile}.bak"

	msg="$1"

	echo -ne "[$(date)]: ${msg}" >> ${logFile}
}

if [ ${HOSTNAME} == "SC8131" || ${HOSTNAME} == "SC8132" ];then
        parseprog="${BINPATH}/parsetime"
        utcprog="${BINPATH}/getUTCtime"
        prog="${BINPATH}/genReport"
else
        parseprog="${BASEDIR}/parsetime"
        utcprog="${BASEDIR}/getUTCtime"
        prog="${BASEDIR}/genReport"
fi

LITE=0
FORMAT="XML"
LOCALTIME=0
COUNTINGEVENTDB=0
INPUT=${strparam}
array=${INPUT//&/ }
for str in ${array}; do
        KEY="`echo ${str} | cut -d "=" -f 1 | tr 'a-z' 'A-Z'`"
        VALUE="`echo ${str} | cut -d "=" -f 2`"
        case ${KEY} in
                "STARTTIME") STARTTIME=`${parseprog} ${VALUE}`
                        ;;
                "ENDTIME") ENDTIME=`${parseprog} ${VALUE}`
                        ;;
                "AGGREGATION") AGGREGATION=${VALUE}
                        ;;
                "FORMAT") FORMAT=${VALUE}
                        ;;
                "LITE") LITE=${VALUE}
                        ;;
                "LOCALTIME") LOCALTIME=${VALUE}
                        ;;
                "COUNTINGEVENTDB") COUNTINGEVENTDB=${VALUE}
                        ;;
        esac
done

if [ ${STARTTIME} -lt 0 || ${ENDTIME} -lt 0 ];then
	echo -ne "invalid time format"
	exit -1
fi

if [ "${LOCALTIME}" != 1 ];then
	LOCALTIME=0
fi
if [ ${LOCALTIME} -eq 1 ];then
	STARTTIME=`${utcprog} ${STARTTIME}`
	ENDTIME=`${utcprog} ${ENDTIME}`
fi

DEMO_DIR='/mnt/flash2/reportpush/'
if [ ! -d "${DEMO_DIR}" ];then
	mkdir -p ${DEMO_DIR}
fi

VCATYPE=`getVCACapabilityItemVal "/root/vcatype"`
REPORT=`${prog} -f ${FORMAT} -s ${STARTTIME} -e ${ENDTIME} -a ${AGGREGATION} -i ${LITE} -l ${LOCALTIME} -t ${VCATYPE} -d ${COUNTINGEVENTDB}`
STATUS=$?
echo -ne "Content-type:text/plain\r\n"
echo -ne "\r\n"
case "${STATUS}" in
	"0") echo -ne "${REPORT}"
		;;
	"2") echo -ne "{\"Status\":2,\"Msg\":\"${REPORT}\"}"
		;;
	*) echo -ne "{\"Status\":$STATUS,\"Msg\":\"internal error\"}"
		logMsg " BASEDIR=${BASEDIR}, STATUS=${STATUS}, VCATYPE=${VCATYPE}, FORMAT=${FORMAT}, STARTTIME=${STARTTIME}, ENDTIME=${ENDTIME}, AGGREGATION=${AGGREGATION}, LITE=${LITE}, LOCALTIME=${LOCALTIME}, COUNTINGEVENTDB=${COUNTINGEVENTDB} \nREPORT = \"${REPORT}\"\n"
		;;
esac
exit 0

